/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
******************************************************************************
**                                                                            
**        Y     Y   OOOO    OOOO   DDDDD     AA
**         Y   Y   O    O  O    O  D    D   A  A
**          Y Y    O    O  O    O  D    D  A    A 
**           Y     O    O  O    O  D    D  AAAAAA
**           Y     O    O  O    O  D    D  A    A
**           Y      OOOO    OOOO   DDDDD   A    A
**
******************************************************************************
******************************************************************************/
/*****************************************************************************
*
*  MODULE :             Smart pointer management
*  SCOPE :              Smart pointer management
*  FILE :               smartp.cc
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      August 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

#ifdef __GNUG__
#pragma implementation
#endif

/* IMPORTS *******************************************************************/

#ifndef __smartp_HXX
#include "smartp.hxx"
#endif

#ifndef __volallocator_HXX
#include "volallocator.hxx"
#endif

/*****************************************************************************/

Ref<Cluster> YOO_ADMIN_CLU ;
Ref<Cluster> YOO_DEF_CLU ;
Ref<Cluster> YOO_TMP_CLU ;

/*= INTERNAL FUNCTION =======================================================*/
yoo_ObjectX::yoo_ObjectX(void* obj) 
/*=
[DESCRIPTION :]
[DIAGNOSTIC :]
=*/
{
  this->assign((ObjectX*)obj) ;
}


/*= INTERNAL FUNCTION =======================================================*/
void yoo_ObjectX::assign(ObjectX* obj) 
/*=
[DESCRIPTION :]
[DIAGNOSTIC :]
=*/
{
  if (obj == NULL) {
    this->_oid = NULL_OID ;
  } else {
    this->_oid = obj->getOid() ;
  }
}


/*= INTERNAL FUNCTION =======================================================*/
void yoo_ObjectX::assign(const yoo_ObjectX& obj) 
/*=
[DESCRIPTION :]
[DIAGNOSTIC :]
=*/
{
  this->_oid = obj._oid ;
}


/*= INTERNAL FUNCTION =======================================================*/
int yoo_ObjectX::operator==(ObjectX* obj) const 
/*=
[DESCRIPTION :]
[DIAGNOSTIC :]
=*/
{
  if (obj == NULL) {
    return this->_oid == NULL_OID ;
  } else {
    return obj->getOid() == this->_oid ;
  } 
}
